; Firmware Furnace Embedded '386SX Projects...
; Standard include file for Journey to the Protected Land programs

;-------------
; Galactic standard PC addresses and so forth

I8259A        = 020h                        ; primary interrupt controller
I8259B        = 0A0h                        ; secondary interrupt controller

I8259A_VECTOR_PM = 50h                      ; Protected-mode vectors
I8259B_VECTOR_PM = 70h                      ;  ... to avoid reserved INT vectors

NS_EOI        = 20h                         ; non-specific End-Of-Interrupt

I8254_SYS     = 40h                         ; system board timers
I8254_SYSCLK  = 1198484                     ; clock input is 14.38 MHz / 12

SYS_CTLS      = 61h                         ; AT system control bit port

KEY_DATA      = 60h                         ; keyboard controller data/status

KEY_CMD       = 64h                         ; keyboard controller command port

RTC_ADDR      = 70h                         ; Real-time clock address port
                                            ;  MSB = 1 disables NMI

RTC_DATA      = 71h                         ; Real-time clock data port


;--------------
; Useful character constants

CANCEL        = 3
BELL          = 7
BS            = 8
CR            = 13
LF            = 10
TAB           = 9
FORMFEED      = 12
ESC_CHAR      = 27
BLANK         = ' '
DEL           = 127
XON           = 17
XOFF          = 19

